%%
%% figures for the chapter about jreplay
%% $Id: jreplayfig.tex,v 1.16 2003-03-09 11:03:04 baurma Exp $
%%


%%
%% Figure "jreplay concept"
%%

\newcommand{\JReplayConceptualFigure}{
}


%%
%% Figure MCIR 1
%%

\newcommand{\MCIRFigureOne}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rlcrl}
\multicolumn{2}{c}{\textbf{Original Bytecode}} &               & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
           &        &               &            &  \\
\texttt{0} & \ldots & $\Rightarrow$ & \texttt{0} & \textbf{ldc \#1 $<$ String \emph{classname} $>$}\\
           &        &               & \texttt{2} & \textbf{invokestatic \#2 $<$void replay.init (String)$>$}       \\
           &        &               & \texttt{5} & \ldots                                  \\
           &        &               &            &  \\
\hline
\end{tabular}
\caption{Bytecode transformations of \texttt{main} method to initialize the replayer}
\label{fig:mcir1}
\end{center}
\end{figure}
}



%%
%% Figure MCIR 2
%%

\newcommand{\MCIRFigureTwo}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{clccl}
\multicolumn{2}{c}{\textbf{Original Bytecode}} &    &
\multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
           &                                  &               &            &  \\
           & \ldots                           &               &            & \ldots                                         \\
\emph{i}   & new \#1$<$\emph{object type}$>$  &               & \emph{i}   & new \#1 $<$\emph{object type}$>$               \\
\emph{i+3} & dup                              &               & \emph{i+3} & dup                                            \\
           & \ldots                           & $\Rightarrow$ &            & \ldots                                         \\
           &                                  &               &            &                                                \\
           & \ldots                           &               &            & \ldots                                         \\
\emph{k}   & invokespecial \#2 $<$init$>$     &               & \emph{k}   & \textbf{dup}                                   \\
\emph{k+3} & \ldots                           &               & \emph{k+1} & invokespecial \#2 $<$init$>$                   \\
           &                                  &               & \emph{k+4} & \textbf{invokestatic \#3 $<$registerThread$>$} \\
           &                                  &               & \emph{k+7} & \ldots                                         \\
           &                                  &               &            &  \\
\hline
\end{tabular}
\caption{Bytecode transformations to register a new thread object}
\label{fig:mcir2}
\end{center}
\end{figure}
}


%%
%% Figure MCIR 3
%%

\newcommand{\MCIRFigureThree}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rlcrl}
\multicolumn{3}{c}{\textbf{Original Bytecode}} & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
           &        &               &            &  \\
\texttt{0} & \ldots & $\Rightarrow$ & \texttt{0} & \textbf{invokestatic \#1 $<$void replay.blockThis() $>$} \\
           &        &               & \texttt{3} & \ldots                          \\
           &        &               &            &  \\
\hline
\end{tabular}
\caption{Bytecode transformations of \texttt{run} methods to retain the replay invariant for newly created threads}
\label{fig:mcir3}
\end{center}
\end{figure}
}



%%
%% Figure MCIR 4
%%

\newcommand{\MCIRFigureFour}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rlccl}
\multicolumn{3}{c}{\textbf{Original Bytecode}} & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
         &        &               &            &  \\
\emph{i} & \ldots & $\Rightarrow$ & \emph{i}   & \textbf{ldc \#1 $<$String \emph{classname} $>$} \\
         &        &               & \emph{i+2} & \textbf{push \emph{method\_index}}       \\
         &        &               & \emph{i+3} & \textbf{push \emph{bytecode\_loc}}       \\
         &        &               & \emph{i+4} & \textbf{invokestatic \#2 $<$ void replay.sync(String,int,int) $>$}  \\
         &        &               & \emph{i+7} & \ldots                                   \\
         &        &               &            &  \\
\hline
\end{tabular}
\caption{Bytecode transformation to force an explicit thread switch}
\label{fig:mcir4}
\end{center}
\end{figure}
}


%%
%% Figure MCIR 5
%%

\newcommand{\MCIRFigureFive}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{clccl}
\multicolumn{3}{c}{\textbf{Original Bytecode}}  & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
         &         &               &             &                                                     \\
\emph{i} & vreturn & $\Rightarrow$ & \emph{i}    & \textbf{invokestatic \#1 $<$void replay.terminate() $>$} \\
         &         &               & \emph{i+3}  & ldc \# $<$ String \emph{classname} $>$              \\
         &         &               & \emph{i+6}  & push \emph{method\_index} $>$                       \\
         &         &               & \emph{i+7}  & push \emph{bytecode\_loc}$>$                        \\
         &         &               & \emph{i+8}  & invokestatic $<$ void replay.sync (String, int, int) $>$  \\
         &         &               & \emph{i+11} & vreturn                                             \\
         &         &               &             &                                                     \\
\hline
\end{tabular}
\caption{Bytecode transformation to release a terminating thread}
\label{fig:mcir5}
\end{center}
\end{figure}
}





%%
%% Figure MCIR 6
%%

\newcommand{\MCIRFigureSix}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{clccl}
\multicolumn{2}{c}{\textbf{Original Bytecode}} &          & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}}            \\
\hline
           &                               &               &             &  \\
\emph{i}   & invokevirtual \#1 $<$wait$>$  & $\Rightarrow$ & \emph{i}    & \textbf{invokestatic $<$replay.setLock(Object) $>$}\\
\emph{i+3} & \ldots                        &               & \emph{i+3}  & ldc \# $<$ String \emph{classname} $>$             \\
   	   &                               &               & \emph{i+6}  & push $<$ \emph{method\_index} $>$                  \\
   	   &                               &               & \emph{i+7}  & push $<$ \emph{bytecode\_loc}$>$                   \\
   	   &                               &               & \emph{i+8}  & invokestatic $<$replay.sync(String, int, int) $>$  \\
   	   &                               &               & \emph{i+11} & \textbf{invokestatic $<$replay.resetLock() $>$}    \\
      	   &                               &               & \emph{i+14} & \ldots                                             \\
           &                               &               &             &  \\
\hline
\end{tabular}
\caption{Bytecode transformation to instrument \texttt{Object.wait}}
\label{fig:mcir6}
\end{center}
\end{figure}
}



%%
%% Figure MCIR 7
%%

\newcommand{\MCIRFigureSeven}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{clccl}
\multicolumn{2}{c}{\textbf{Original Bytecode}} &               & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
           &                   &                 &              &                                                     \\
\emph{i}   & invokevirtual \#1 $<$notify$>$  & $\Rightarrow$    & \emph{i} & ldc \#1 $<$String \emph{classname}$>$    \\
\emph{i+3} & \ldots            &                 & \emph{i+1}   & push \emph{method\_index}                           \\
           &                   &                 & \emph{i+4}   & push \emph{bytecode\_loc}                           \\
           &                   &                 & \emph{i+5}   & invokestatic \#2 $<$void sync$>$                    \\
           &                   &                 & \emph{i+6}   & \ldots                                              \\
           &                   &                 &              &                                                     \\
\hline
\end{tabular}
\caption{Bytecode transformation to instrument \texttt{Object.notify}}
\label{fig:mcir7}
\end{center}
\end{figure}
}



%%
%% Figure MCIR 8
%%

\newcommand{\MCIRFigureEight}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rlcrl}
\multicolumn{2}{c}{\textbf{Original Bytecode}} &  & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
         &                                          &               & & \\
         & \ldots                                   &               & & \ldots \\
\emph{i} & invokevirtual \#1 $<$interrupt$>$ & $\Rightarrow$ & \emph{i} & \textbf{invokestatic} \textbf{\#2} \textbf{$<$ interruptSelf(Thread) $>$} \\
         & \ldots                                   &               & & \ldots \\
         &                                          &               & & \\	 
\hline
\end{tabular}
\caption{Bytecode transformation to instrument \texttt{Thread.interrupt}}
\label{fig:mcir8}
\end{center}
\end{figure}
}



%%
%% Figure MCIR 9
%%

\newcommand{\MCIRFigureNine}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rlcrl}
\multicolumn{2}{c}{\textbf{Original Bytecode}} &               & \multicolumn{2}{c}{\textbf{Instrumented Bytecode}} \\
\hline
           &                                    &               &            &                                       \\
           & \ldots                             &               &            & \ldots                                \\
\emph{i}   & invokestatic \#1 $<$Thread.join$>$ & $\Rightarrow$ & \emph{i}   & ldc \#2 $<$String \emph{classname}$>$ \\
\emph{i+3} & \ldots                             &               & \emph{i+2} & push \emph{method\_index}             \\
           &                                    &               & \emph{i+5} & push \emph{bytecode\_loc}             \\
           &                                    &               & \emph{i+6} & invokestatic \#3 $<$void sync$>$      \\
           &                                    &               & \emph{i+9} & \ldots                                \\
           &                                    &               &            &                                       \\
\hline
\end{tabular}
\caption{Bytecode transformation to instrument \texttt{Thread.join}}
\label{fig:mcir9}
\end{center}
\end{figure}
}

%%
%% Transformation Summary Figure
%%

\newcommand{\TransformationSummaryFigure}{
\begin{figure}[ht!]
\begin{center}
\begin{tabular}{rll}
\textbf{Rule} & \textbf{Location}    & \textbf{Instrumentation}              \\
\hline                                                                       \\
1 & Begin of \texttt{main} method      & Insert call to \texttt{replay.init}           \\
2 & Explicit thread change locations   & Insert call to \texttt{replay.sync}           \\
3 & Creation of new thread objects     & Insert call to \\
  &                                    & \texttt{replay.registerThread} \\
4 & Begin of \texttt{run} method       & Insert call to \texttt{replay.blockThis}      \\
5 & \texttt{vreturn} instructions in \texttt{run} methods & Invoke \texttt{replay.terminate} \\
6 & \texttt{Object.wait}                          & Remove call and parameters, \\
  &                                               & temporarily overwrite lock  \\
7 & \texttt{Object.notify} and \texttt{notifyAll} & Remove call \\
8 & \texttt{Thread.interrupt}                     & Replace by call to \\
  &                                               & \texttt{replay.interruptSelf} \\
9 & \texttt{Thread.join}                          & Remove calls and parameters \\
\hline
\end{tabular}
\end{center}
\caption{Summary of instrumented bytecode transformations}
\label{fig:mcirsummary}
\end{figure}
}

